--- old/usr/src/uts/intel/ia32/syscall/getcontext.c	2013-01-23 13:19:09.905031364 +0000
+++ new/usr/src/uts/intel/ia32/syscall/getcontext.c	2013-01-23 13:19:09.914480403 +0000
@@ -184,6 +184,8 @@
 	ucontext_t *ucp;
 	klwp_t *lwp = ttolwp(curthread);
 	stack_t dummy_stk;
+	caddr_t xregs = NULL;
+	int xregs_size = 0;
 
 	/*
 	 * In future releases, when the ucontext structure grows,
@@ -228,11 +230,23 @@
 			return (set_errno(EFAULT));
 		}
 
+		/*
+		 * Get extra register state.
+		 */
+		xregs_clrptr(lwp, &uc);
+
 		restorecontext(&uc);
 
 		if ((uc.uc_flags & UC_STACK) && (lwp->lwp_ustack != 0))
 			(void) copyout(&uc.uc_stack, (stack_t *)lwp->lwp_ustack,
 			    sizeof (uc.uc_stack));
+
+		/*
+		 * Free extra register state.
+		 */
+		if (xregs_size)
+			kmem_free(xregs, xregs_size);
+
 		return (0);
 
 	case GETUSTACK:
